<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Camera Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_camera.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_camera-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Camera Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate virtual projective cameras.  
 <a href="class_camera.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_camera_8hpp_source.html">Camera.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab31d5c9fab32c5a72d54b1ae99b81ef2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ab31d5c9fab32c5a72d54b1ae99b81ef2">Camera</a> (double _l, double _r, double _t, double _b, double _d, int _nx, int _ny, int _viewport_width, int _viewport_height)</td></tr>
<tr class="separator:ab31d5c9fab32c5a72d54b1ae99b81ef2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a01f94c3543f56ede7af49dc778f19331"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a01f94c3543f56ede7af49dc778f19331">Camera</a> ()</td></tr>
<tr class="separator:a01f94c3543f56ede7af49dc778f19331"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa16f32bf8c56b12f31dfcf6f39231431"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#aa16f32bf8c56b12f31dfcf6f39231431">look_at</a> (<a class="el" href="class_vec.html">Vec</a> eye, <a class="el" href="class_vec.html">Vec</a> at, <a class="el" href="class_vec.html">Vec</a> up)</td></tr>
<tr class="separator:aa16f32bf8c56b12f31dfcf6f39231431"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4b0e9ea41d0f132d2fe7a7349d919e4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ae4b0e9ea41d0f132d2fe7a7349d919e4">setTransform</a> (<a class="el" href="class_transform.html">Transform</a> *<a class="el" href="class_camera.html#a33bab7beb6bd121e399776c37e529471">tf</a>)</td></tr>
<tr class="memdesc:ae4b0e9ea41d0f132d2fe7a7349d919e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the camera's pose using a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node.  <a href="#ae4b0e9ea41d0f132d2fe7a7349d919e4">More...</a><br /></td></tr>
<tr class="separator:ae4b0e9ea41d0f132d2fe7a7349d919e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3dd8170ac8e2ddb7175ac2ef5e02ac83"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a3dd8170ac8e2ddb7175ac2ef5e02ac83">transform</a> ()</td></tr>
<tr class="memdesc:a3dd8170ac8e2ddb7175ac2ef5e02ac83"><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates the camera's pose using a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node set with setTransform - don't call it directly.  <a href="#a3dd8170ac8e2ddb7175ac2ef5e02ac83">More...</a><br /></td></tr>
<tr class="separator:a3dd8170ac8e2ddb7175ac2ef5e02ac83"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a187bed1cba664e132932dcb94ab99486"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a187bed1cba664e132932dcb94ab99486">transform</a> (<a class="el" href="class_mat.html">Mat</a> m)</td></tr>
<tr class="separator:a187bed1cba664e132932dcb94ab99486"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab08bb2f3987c704bb67aa9475f617976"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ab08bb2f3987c704bb67aa9475f617976">move</a> (<a class="el" href="class_vec.html">Vec</a> motion)</td></tr>
<tr class="memdesc:ab08bb2f3987c704bb67aa9475f617976"><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies a motion vector to the camera.  <a href="#ab08bb2f3987c704bb67aa9475f617976">More...</a><br /></td></tr>
<tr class="separator:ab08bb2f3987c704bb67aa9475f617976"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b34435333ba29dca4a9e136322a8923"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a6b34435333ba29dca4a9e136322a8923">move_at</a> (<a class="el" href="class_vec.html">Vec</a> motion)</td></tr>
<tr class="memdesc:a6b34435333ba29dca4a9e136322a8923"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moves the camera to a given location.  <a href="#a6b34435333ba29dca4a9e136322a8923">More...</a><br /></td></tr>
<tr class="separator:a6b34435333ba29dca4a9e136322a8923"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9b9138bb945ff40cb3f7fe28dc6c5cb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_ray.html">Ray</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ac9b9138bb945ff40cb3f7fe28dc6c5cb">view_ray</a> (const double i, const double j)</td></tr>
<tr class="memdesc:ac9b9138bb945ff40cb3f7fe28dc6c5cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the viewing ray that passes through a given pixel (i,j)  <a href="#ac9b9138bb945ff40cb3f7fe28dc6c5cb">More...</a><br /></td></tr>
<tr class="separator:ac9b9138bb945ff40cb3f7fe28dc6c5cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a8a30c1d630ed7a772dca55e7275bc5cb"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a8a30c1d630ed7a772dca55e7275bc5cb">l</a></td></tr>
<tr class="memdesc:a8a30c1d630ed7a772dca55e7275bc5cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">u coordinate, in the camera's uvw frame of reference, of the viewing window's left cutting plane  <a href="#a8a30c1d630ed7a772dca55e7275bc5cb">More...</a><br /></td></tr>
<tr class="separator:a8a30c1d630ed7a772dca55e7275bc5cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4309dd7d7a05fd6346db6de286c6ee5a"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a4309dd7d7a05fd6346db6de286c6ee5a">r</a></td></tr>
<tr class="memdesc:a4309dd7d7a05fd6346db6de286c6ee5a"><td class="mdescLeft">&#160;</td><td class="mdescRight">u coordinate, in the camera's uvw frame of reference, of the viewing window's right cutting plane  <a href="#a4309dd7d7a05fd6346db6de286c6ee5a">More...</a><br /></td></tr>
<tr class="separator:a4309dd7d7a05fd6346db6de286c6ee5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d5917a7f2bbd9a43c476d6db6fd6f1d"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a4d5917a7f2bbd9a43c476d6db6fd6f1d">t</a></td></tr>
<tr class="memdesc:a4d5917a7f2bbd9a43c476d6db6fd6f1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">v coordinate, in the camera's uvw frame of reference, of the viewing window's top cutting plane  <a href="#a4d5917a7f2bbd9a43c476d6db6fd6f1d">More...</a><br /></td></tr>
<tr class="separator:a4d5917a7f2bbd9a43c476d6db6fd6f1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac38bcfc28d7ab935ea0d3ccac7646939"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ac38bcfc28d7ab935ea0d3ccac7646939">b</a></td></tr>
<tr class="memdesc:ac38bcfc28d7ab935ea0d3ccac7646939"><td class="mdescLeft">&#160;</td><td class="mdescRight">v coordinate, in the camera's uvw frame of reference, of the viewing window's bottom cutting plane  <a href="#ac38bcfc28d7ab935ea0d3ccac7646939">More...</a><br /></td></tr>
<tr class="separator:ac38bcfc28d7ab935ea0d3ccac7646939"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1375dd3b08417a179e52746cdf4ddaf2"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a1375dd3b08417a179e52746cdf4ddaf2">d</a></td></tr>
<tr class="memdesc:a1375dd3b08417a179e52746cdf4ddaf2"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s focal distance, i.e., the w coordinate of the viewing window in the camera's uvw frame of reference.  <a href="#a1375dd3b08417a179e52746cdf4ddaf2">More...</a><br /></td></tr>
<tr class="separator:a1375dd3b08417a179e52746cdf4ddaf2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab24cd1c55c90594697eaff3bb6b6d93a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ab24cd1c55c90594697eaff3bb6b6d93a">nx</a></td></tr>
<tr class="memdesc:ab24cd1c55c90594697eaff3bb6b6d93a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Width, in pixels, of the rendered image.  <a href="#ab24cd1c55c90594697eaff3bb6b6d93a">More...</a><br /></td></tr>
<tr class="separator:ab24cd1c55c90594697eaff3bb6b6d93a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61a6f5c9296cba95f70190ee228b9ef6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a61a6f5c9296cba95f70190ee228b9ef6">ny</a></td></tr>
<tr class="memdesc:a61a6f5c9296cba95f70190ee228b9ef6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Height, in pixels, of the rendered image.  <a href="#a61a6f5c9296cba95f70190ee228b9ef6">More...</a><br /></td></tr>
<tr class="separator:a61a6f5c9296cba95f70190ee228b9ef6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ef497a0e254c94753b835c1f3d5c85f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a6ef497a0e254c94753b835c1f3d5c85f">e</a></td></tr>
<tr class="memdesc:a6ef497a0e254c94753b835c1f3d5c85f"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s location in the world frame(eye)  <a href="#a6ef497a0e254c94753b835c1f3d5c85f">More...</a><br /></td></tr>
<tr class="separator:a6ef497a0e254c94753b835c1f3d5c85f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aceeb867ba2fd864603c1ae83e035fa0a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#aceeb867ba2fd864603c1ae83e035fa0a">u</a></td></tr>
<tr class="memdesc:aceeb867ba2fd864603c1ae83e035fa0a"><td class="mdescLeft">&#160;</td><td class="mdescRight">u-axis of the camera's frame of reference  <a href="#aceeb867ba2fd864603c1ae83e035fa0a">More...</a><br /></td></tr>
<tr class="separator:aceeb867ba2fd864603c1ae83e035fa0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a458286722dd30e56e1efeaf1fd4e011c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a458286722dd30e56e1efeaf1fd4e011c">v</a></td></tr>
<tr class="memdesc:a458286722dd30e56e1efeaf1fd4e011c"><td class="mdescLeft">&#160;</td><td class="mdescRight">v-axis of the camera's frame of reference  <a href="#a458286722dd30e56e1efeaf1fd4e011c">More...</a><br /></td></tr>
<tr class="separator:a458286722dd30e56e1efeaf1fd4e011c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4cb433e0f9ee4c41ab1c0c52b891bd2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#ae4cb433e0f9ee4c41ab1c0c52b891bd2">w</a></td></tr>
<tr class="memdesc:ae4cb433e0f9ee4c41ab1c0c52b891bd2"><td class="mdescLeft">&#160;</td><td class="mdescRight">w-axis of the camera's frame of reference  <a href="#ae4cb433e0f9ee4c41ab1c0c52b891bd2">More...</a><br /></td></tr>
<tr class="separator:ae4cb433e0f9ee4c41ab1c0c52b891bd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a72018306ef284349e1f30d7d64a5bd2b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a72018306ef284349e1f30d7d64a5bd2b">a</a></td></tr>
<tr class="memdesc:a72018306ef284349e1f30d7d64a5bd2b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s "looking-at" point in the world frame.  <a href="#a72018306ef284349e1f30d7d64a5bd2b">More...</a><br /></td></tr>
<tr class="separator:a72018306ef284349e1f30d7d64a5bd2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c5b354fc3564c9e7bca14fa55bd2ff1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a6c5b354fc3564c9e7bca14fa55bd2ff1">viewport_width</a></td></tr>
<tr class="memdesc:a6c5b354fc3564c9e7bca14fa55bd2ff1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Viewport's width (rendered image is scaled to fit the viewport)  <a href="#a6c5b354fc3564c9e7bca14fa55bd2ff1">More...</a><br /></td></tr>
<tr class="separator:a6c5b354fc3564c9e7bca14fa55bd2ff1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89e1485eea89a602c152b561d17fbbdb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a89e1485eea89a602c152b561d17fbbdb">viewport_height</a></td></tr>
<tr class="memdesc:a89e1485eea89a602c152b561d17fbbdb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Viewport's height (rendered image is scaled to fit the viewport)  <a href="#a89e1485eea89a602c152b561d17fbbdb">More...</a><br /></td></tr>
<tr class="separator:a89e1485eea89a602c152b561d17fbbdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33bab7beb6bd121e399776c37e529471"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#a33bab7beb6bd121e399776c37e529471">tf</a></td></tr>
<tr class="memdesc:a33bab7beb6bd121e399776c37e529471"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>.  <a href="#a33bab7beb6bd121e399776c37e529471">More...</a><br /></td></tr>
<tr class="separator:a33bab7beb6bd121e399776c37e529471"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb2d4c41d0188be81f8fb2d01307fa99"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_camera.html#aeb2d4c41d0188be81f8fb2d01307fa99">orientation_fixed</a></td></tr>
<tr class="memdesc:aeb2d4c41d0188be81f8fb2d01307fa99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag to state whether the camera orientation is to be changed by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> tf.  <a href="#aeb2d4c41d0188be81f8fb2d01307fa99">More...</a><br /></td></tr>
<tr class="separator:aeb2d4c41d0188be81f8fb2d01307fa99"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate virtual projective cameras. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab31d5c9fab32c5a72d54b1ae99b81ef2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab31d5c9fab32c5a72d54b1ae99b81ef2">&sect;&nbsp;</a></span>Camera() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Camera::Camera </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_l</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_nx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_ny</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_viewport_width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_viewport_height</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>A projective camera constructor. The camera is set at (0,0,0), it is vertically aligned with the y-axis, and it it is looking at (0,0,-10).</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_l</td><td>u coordinate, in the camera's uvw frame of reference, of the viewing window's left cutting plane </td></tr>
    <tr><td class="paramname">_r</td><td>u coordinate, in the camera's uvw frame of reference, of the viewing window's right cutting plane </td></tr>
    <tr><td class="paramname">_t</td><td>v coordinate, in the camera's uvw frame of reference, of the viewing window's top cutting plane </td></tr>
    <tr><td class="paramname">_b</td><td>v coordinate, in the camera's uvw frame of reference, of the viewing window's bottom cutting plane </td></tr>
    <tr><td class="paramname">_d</td><td><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s focal distance, i.e., the w coordinate of the viewing window in the camera's uvw frame of reference </td></tr>
    <tr><td class="paramname">_nx</td><td>Width, in pixels, of the rendered image </td></tr>
    <tr><td class="paramname">_ny</td><td>Height, in pixels, of the rendered image </td></tr>
    <tr><td class="paramname">_viewport_width</td><td>Viewport's width (rendered image is scaled to fit the viewport) </td></tr>
    <tr><td class="paramname">_viewport_height</td><td>Viewport's height (rendered image is scaled to fit the viewport) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a01f94c3543f56ede7af49dc778f19331"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a01f94c3543f56ede7af49dc778f19331">&sect;&nbsp;</a></span>Camera() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Camera::Camera </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa16f32bf8c56b12f31dfcf6f39231431"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa16f32bf8c56b12f31dfcf6f39231431">&sect;&nbsp;</a></span>look_at()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::look_at </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>eye</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>at</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>up</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the camera's pose with the eye-gaze-up convention. The goal is to set the pose of the camera so that a given point 'at' is seen from a given desired location 'eye', while ensuring that an 'up' vector is vertically aligned with the camera. This call cancels the automatic application of any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node that has been associated to this camera via setTransform.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">eye</td><td>3D point where to look 'from' </td></tr>
    <tr><td class="paramname">at</td><td>3D point where to look 'at' </td></tr>
    <tr><td class="paramname">up</td><td>3D vector vertically aligned with camera (constraint to set the camera's orientation) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ab08bb2f3987c704bb67aa9475f617976"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab08bb2f3987c704bb67aa9475f617976">&sect;&nbsp;</a></span>move()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::move </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>motion</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Applies a motion vector to the camera. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">motion</td><td>Motion 3D vector to be applied to the camera's current pose </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a6b34435333ba29dca4a9e136322a8923"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b34435333ba29dca4a9e136322a8923">&sect;&nbsp;</a></span>move_at()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::move_at </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>motion</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Moves the camera to a given location. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">motion</td><td>New 3D location for the camera </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae4b0e9ea41d0f132d2fe7a7349d919e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae4b0e9ea41d0f132d2fe7a7349d919e4">&sect;&nbsp;</a></span>setTransform()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::setTransform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>tf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets the camera's pose using a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tf</td><td>Pointer to <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to be applied to the camera </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3dd8170ac8e2ddb7175ac2ef5e02ac83"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dd8170ac8e2ddb7175ac2ef5e02ac83">&sect;&nbsp;</a></span>transform() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::transform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Updates the camera's pose using a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node set with setTransform - don't call it directly. </p>

</div>
</div>
<a id="a187bed1cba664e132932dcb94ab99486"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a187bed1cba664e132932dcb94ab99486">&sect;&nbsp;</a></span>transform() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Camera::transform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_mat.html">Mat</a>&#160;</td>
          <td class="paramname"><em>m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the camera's pose using a transformation matrix. This call cancels the automatic application of any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node that has been associated to this camera via setTransform.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">m</td><td>The transformation matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac9b9138bb945ff40cb3f7fe28dc6c5cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac9b9138bb945ff40cb3f7fe28dc6c5cb">&sect;&nbsp;</a></span>view_ray()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_ray.html">Ray</a> Camera::view_ray </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes the viewing ray that passes through a given pixel (i,j) </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a72018306ef284349e1f30d7d64a5bd2b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a72018306ef284349e1f30d7d64a5bd2b">&sect;&nbsp;</a></span>a</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Camera::a</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s "looking-at" point in the world frame. </p>

</div>
</div>
<a id="ac38bcfc28d7ab935ea0d3ccac7646939"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac38bcfc28d7ab935ea0d3ccac7646939">&sect;&nbsp;</a></span>b</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Camera::b</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>v coordinate, in the camera's uvw frame of reference, of the viewing window's bottom cutting plane </p>

</div>
</div>
<a id="a1375dd3b08417a179e52746cdf4ddaf2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1375dd3b08417a179e52746cdf4ddaf2">&sect;&nbsp;</a></span>d</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Camera::d</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s focal distance, i.e., the w coordinate of the viewing window in the camera's uvw frame of reference. </p>

</div>
</div>
<a id="a6ef497a0e254c94753b835c1f3d5c85f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6ef497a0e254c94753b835c1f3d5c85f">&sect;&nbsp;</a></span>e</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Camera::e</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>'s location in the world frame(eye) </p>

</div>
</div>
<a id="a8a30c1d630ed7a772dca55e7275bc5cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a30c1d630ed7a772dca55e7275bc5cb">&sect;&nbsp;</a></span>l</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Camera::l</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>u coordinate, in the camera's uvw frame of reference, of the viewing window's left cutting plane </p>

</div>
</div>
<a id="ab24cd1c55c90594697eaff3bb6b6d93a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab24cd1c55c90594697eaff3bb6b6d93a">&sect;&nbsp;</a></span>nx</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Camera::nx</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Width, in pixels, of the rendered image. </p>

</div>
</div>
<a id="a61a6f5c9296cba95f70190ee228b9ef6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a61a6f5c9296cba95f70190ee228b9ef6">&sect;&nbsp;</a></span>ny</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Camera::ny</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Height, in pixels, of the rendered image. </p>

</div>
</div>
<a id="aeb2d4c41d0188be81f8fb2d01307fa99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb2d4c41d0188be81f8fb2d01307fa99">&sect;&nbsp;</a></span>orientation_fixed</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Camera::orientation_fixed</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag to state whether the camera orientation is to be changed by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> tf. </p>

</div>
</div>
<a id="a4309dd7d7a05fd6346db6de286c6ee5a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4309dd7d7a05fd6346db6de286c6ee5a">&sect;&nbsp;</a></span>r</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Camera::r</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>u coordinate, in the camera's uvw frame of reference, of the viewing window's right cutting plane </p>

</div>
</div>
<a id="a4d5917a7f2bbd9a43c476d6db6fd6f1d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d5917a7f2bbd9a43c476d6db6fd6f1d">&sect;&nbsp;</a></span>t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Camera::t</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>v coordinate, in the camera's uvw frame of reference, of the viewing window's top cutting plane </p>

</div>
</div>
<a id="a33bab7beb6bd121e399776c37e529471"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a33bab7beb6bd121e399776c37e529471">&sect;&nbsp;</a></span>tf</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a>* Camera::tf</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>. </p>

</div>
</div>
<a id="aceeb867ba2fd864603c1ae83e035fa0a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aceeb867ba2fd864603c1ae83e035fa0a">&sect;&nbsp;</a></span>u</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Camera::u</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>u-axis of the camera's frame of reference </p>

</div>
</div>
<a id="a458286722dd30e56e1efeaf1fd4e011c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a458286722dd30e56e1efeaf1fd4e011c">&sect;&nbsp;</a></span>v</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Camera::v</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>v-axis of the camera's frame of reference </p>

</div>
</div>
<a id="a89e1485eea89a602c152b561d17fbbdb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89e1485eea89a602c152b561d17fbbdb">&sect;&nbsp;</a></span>viewport_height</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Camera::viewport_height</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Viewport's height (rendered image is scaled to fit the viewport) </p>

</div>
</div>
<a id="a6c5b354fc3564c9e7bca14fa55bd2ff1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6c5b354fc3564c9e7bca14fa55bd2ff1">&sect;&nbsp;</a></span>viewport_width</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Camera::viewport_width</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Viewport's width (rendered image is scaled to fit the viewport) </p>

</div>
</div>
<a id="ae4cb433e0f9ee4c41ab1c0c52b891bd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae4cb433e0f9ee4c41ab1c0c52b891bd2">&sect;&nbsp;</a></span>w</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Camera::w</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>w-axis of the camera's frame of reference </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_camera_8hpp_source.html">Camera.hpp</a></li>
<li>src/<a class="el" href="_camera_8cpp.html">Camera.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_camera.html">Camera</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
